indexing
	description: "Objects that execute features of class BI_LINKABLE"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	BI_LINKABLE_TESTER

inherit
	CLASS_TESTER

	BI_LINKABLE [INTEGER_32_REF]
		rename
			item as cell_item
		end

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (10)
			test2 (5)
			test3 (5)
			test4 (5)
			test5 (10)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (100)
			test2 (50)
			test3 (50)
			test4 (50)
			test5 (100)
		end

feature {NONE} -- Parameters
	item_bound: INTEGER is 100

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1 (put and forget) `count' times
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				set_item (Current)
				create l1
				set_item (l1)
				create l2
				set_item (l2)
				put_left (l1)
				put_right (l2)
				forget_left
				forget_right
				i := i + 1
			end
		end

	test2 (count: INTEGER) is
			-- Test 2 (nonfreash put) `count'*3 times
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				set_item (Current)
				create l1
				set_item (l1)
				create l2
				set_item (l2)
				l1.put_right (Current)
				l2.put_right (Current)
				l2.put_right (l1)
				put_left (l1)
				l2.put_left (l1)
				l2.put_left (Current)
				l1.forget_right
				l1.forget_left
				l2.forget_right
				l2.forget_left
				forget_right
--				forget_left	-- Bug
				i := i + 1
			end
		end

	test3 (count: INTEGER) is
			-- Test 3 (link Void) `count' times
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				set_item (Current)
				put_left (Void)
				put_right (Void)
--				forget_left -- Bug
				forget_right
				i := i + 1
			end
		end

	test4 (count: INTEGER) is
			-- Test 3 (circular) `count'*3 times
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				create l1
				set_item (l1)
				create l2
				set_item (l2)
				l1.put_right (Current)
				put_right (l2)
				l2.put_right (l1)
				l1.put_left (Current)
				put_left (l2)
				l2.put_left (l1)
				l1.forget_left
				forget_right
				l2.forget_left
				l1.forget_right
				forget_left
				l2.forget_right
				i := i + 1
			end
		end

	test5 (count: INTEGER) is
			-- Test 5 (only simple operations) => `count'/2 times
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				l1 := Void
				l2 := Void
				if random.decide (0.5) then
					create l1
					set_item (l1)
				end
				random.forth
				if random.decide (0.5) then
					create l2
					set_item (l2)
				end
				random.forth
				if random.decide (0.5) then
					simple_put_right (l1)
					simple_put_left (l2)
				else
					simple_put_left (l1)
					simple_put_right (l2)
				end
				random.forth
				if random.decide (0.5) then
					simple_forget_right
					simple_forget_left
				else
					simple_forget_left
					simple_forget_right
				end
				random.forth
				i := i + 1
			end
		end

feature {NONE} -- Implemenatation
	l1, l2: like Current

	set_item (l: BI_LINKABLE [INTEGER_32_REF]) is
			-- Set random item in `l'
		do
			if random.decide (0.1) then
				l.put (Void)
			else
				random.forth
				l.put (random.bounded_item (0, item_bound).to_reference)
			end
			random.forth
		end


end
