indexing
	description: "Objects that execute features of class ST_WORD_WRAPPER"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	ST_WORD_WRAPPER_TESTER

inherit
	CLASS_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (10)
			test2 (20)
			test3 (1)
			test4 (19)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (100)
			test2 (200)
			test3 (1)
			test4 (199)
		end

feature {NONE} -- Parameters


feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1 (create, set and wrap) `count' times
		local
			i: INTEGER
			s: STRING
		do
			from
				i := 1
			until
				i > count
			loop
				create wrapper.make
				wrapper.set_maximum_text_width (
					random.bounded_item (wrapper.new_line_indentation + 1, wrapper.default_maximum_text_width * 2))
				random.forth
				wrapper.set_new_line_indentation (random.bounded_item (0, wrapper.maximum_text_width - 1))
				random.forth
				s := wrapper.wrapped_string (substring(text))
				i := i + 1
			end
		end

	test2 (count: INTEGER) is
			-- Test 2 (create once) `count' times
		local
			i: INTEGER
			s: STRING
		do
			create wrapper.make
			from
				i := 1
			until
				i > count
			loop
				wrapper.set_maximum_text_width (
					random.bounded_item (wrapper.new_line_indentation + 1, wrapper.default_maximum_text_width * 2))
				random.forth
				wrapper.set_new_line_indentation (random.bounded_item (0, wrapper.maximum_text_width - 1))
				random.forth
				s := wrapper.wrapped_string (substring(text))
				i := i + 1
			end
		end

	test3 (count: INTEGER) is
			-- Test 3 (empty text) `count' times
		local
			i: INTEGER
			s: STRING
		do
			from
				i := 1
			until
				i > count
			loop
				create wrapper.make
				wrapper.set_maximum_text_width (
					random.bounded_item (wrapper.new_line_indentation + 1, wrapper.default_maximum_text_width * 2))
				random.forth
				wrapper.set_new_line_indentation (random.bounded_item (0, wrapper.maximum_text_width - 1))
				random.forth
				s := wrapper.wrapped_string ("")
				i := i + 1
			end
		end

	test4 (count: INTEGER) is
			-- Test 4 (text with different separators) `count' times
		local
			i: INTEGER
			s: STRING
		do
			from
				i := 1
			until
				i > count
			loop
				create wrapper.make
				wrapper.set_maximum_text_width (
					random.bounded_item (wrapper.new_line_indentation + 1, wrapper.default_maximum_text_width * 2))
				random.forth
				wrapper.set_new_line_indentation (random.bounded_item (0, wrapper.maximum_text_width - 1))
				random.forth
				s := wrapper.wrapped_string (substring(strange_text))
				i := i + 1
			end
		end

feature {NONE} -- Implementation
	wrapper: ST_WORD_WRAPPER
end
