indexing
	description: "Objects that exercise features of class TRAFFIC_TAXI"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	TRAFFIC_TAXI_TESTER

inherit
	TRAFFIC_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (20)
			test2 (10)
			test3 (20)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (200)
			test2 (100)
			test3 (200)
		end

feature {NONE} -- Parameters
	point_count_bound: INTEGER is 30

	creation_frequency: INTEGER is 3

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1 (random values)
	local
		i: INTEGER
		point_randomizer: TRAFFIC_POINT_RANDOMIZER
	do
		city := Void
		taxi := Void
		from
			i := 1
		until
			i > count
		loop
			if i \\ creation_frequency = 1 then
				city := random_city (1000)
				create point_randomizer.make (city.center, city.radius)
				point_randomizer.generate_point_array (random.bounded_item (2, point_count_bound))
				randomize_list (point_randomizer.last_array)
				create taxi.make_random (point_randomizer.last_array)
			end
			if random.decide (0.5) then
				taxi.highlight
			else
				taxi.unhighlight
			end
			random.forth
			taxi.set_speed (random.bounded_real_item (0.0, 100.0))
			random.forth
			taxi.load (random.bounded_item (0, taxi.capacity - taxi.count))
			random.forth
			if i \\ 4 = 0 then
				execute_functions
			end
			taxi.take (bounded_random_point (taxi.location, 100), bounded_random_point (city.center, city.radius))
			if i \\ 4 = 1 then
				execute_functions
			end
			from
			until
				taxi.poly_cursor.after
			loop
				taxi.move_next
			end
			if i \\ 4 = 2 then
				execute_functions
			end
			taxi.advance
			if i \\ 4 = 3 then
				execute_functions
			end
			taxi.unload (random.bounded_item (0, taxi.count))
			random.forth
			i := i + 1
		end
	end

	test2 (count: INTEGER) is
			-- Test 2 (zero points)
	local
		i, j: INTEGER
		points: DS_ARRAYED_LIST [TRAFFIC_POINT]
	do
		city := Void
		taxi := Void
		from
			i := 1
		until
			i > count
		loop
			if i \\ creation_frequency = 1 then
				create points.make (random.bounded_item (2, point_count_bound))
				create city.make (random.alpha_string_nonempty_item (20))
				random.forth
				from
					j := 1
				until
					j > points.capacity
				loop
					points.put_last (origin)
					j := j + 1
				end
				create taxi.make_random (points)
			else
				city := Void
			end
			if random.decide (0.5) then
				taxi.highlight
			else
				taxi.unhighlight
			end
			random.forth
			taxi.set_speed (random.bounded_real_item (0.0, 100.0))
			random.forth
			taxi.load (random.bounded_item (0, taxi.capacity - taxi.count))
			random.forth
			if i \\ 4 = 0 then
				execute_functions
			end
			taxi.take (origin, origin)
			if i \\ 4 = 1 then
				execute_functions
			end
			from
			until
				taxi.poly_cursor.after
			loop
				taxi.move_next
			end
			if i \\ 4 = 2 then
				execute_functions
			end
			taxi.advance
			if i \\ 4 = 3 then
				execute_functions
			end
			taxi.unload (random.bounded_item (0, taxi.count))
			random.forth
			i := i + 1
		end
	end

	test3 (count: INTEGER) is
			-- Test 3 (changed order)
	local
		i: INTEGER
		point_randomizer: TRAFFIC_POINT_RANDOMIZER
	do
		city := Void
		taxi := Void
		from
			i := 1
		until
			i > count
		loop
			if i \\ creation_frequency = 1 then
				city := random_city (1000)
				create point_randomizer.make (city.center, city.radius)
				point_randomizer.generate_point_array (random.bounded_item (2, point_count_bound))
				randomize_list (point_randomizer.last_array)
				create taxi.make_random (point_randomizer.last_array)
			end
			if random.decide (0.5) then
				taxi.highlight
			else
				taxi.unhighlight
			end
			random.forth
			taxi.set_speed (random.bounded_real_item (0.0, 100.0))
			random.forth
			if random.decide (0.5) then
				taxi.advance
			end
			random.forth
			if i \\ 3 = 0 then
				execute_functions
			end
			taxi.take (bounded_random_point (taxi.location, 100), bounded_random_point (city.center, city.radius))
			if i \\ 3 = 1 then
				execute_functions
			end
			from
			until
				taxi.poly_cursor.after
			loop
				taxi.move_next
			end
			if i \\ 3 = 2 then
				execute_functions
			end
			taxi.load (random.bounded_item (0, taxi.capacity - taxi.count))
			random.forth
			taxi.unload (random.bounded_item (0, taxi.count))
			random.forth
			i := i + 1
		end
	end
feature {NONE} -- Implementation
	taxi: TRAFFIC_TAXI

	city: TRAFFIC_CITY

	execute_functions is
			-- Execute functions on `taxi'
		local
			b: BOOLEAN
		do
			b := taxi.is_insertable (city)
			b := taxi.is_removable
		end

	randomize_list (list: DS_ARRAYED_LIST [TRAFFIC_POINT]) is
			-- Randomize list state (not items)
		do
			list.go_i_th (random.bounded_item (0, list.count + 1))
			random.forth
			list.resize (random.bounded_item (list.count, list.count * 2))
			random.forth
--			if random.decide (0.5) then
--				list.set_equality_tester (t)
--			end
		end

end
