indexing
	description: "Objects that execute features of some class from Traffic"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

deferred class
	TRAFFIC_TESTER

inherit
	CLASS_TESTER

	DOUBLE_MATH

feature -- Access
	origin: TRAFFIC_POINT is
			-- Origin point
		once
			create Result.make (0, 0)
		end

	bounded_random_point (p: TRAFFIC_POINT; max_dist: DOUBLE): TRAFFIC_POINT is
			-- Random point, which is not further from `p' than `max_dist'
		require
			p_exists: p /= Void
			max_dist_non_negative: max_dist >= 0
		local
			x, y: DOUBLE
		do
			if max_dist > 0.0 then
				x := random.bounded_real_item (- max_dist, max_dist)
				random.forth
				y := random.bounded_real_item (- sqrt (max_dist^2 - x^2), sqrt (max_dist^2 - x^2))
				random.forth
				create Result.make (p.x + x, p.y + y)
			else
				Result := p.twin
			end
		ensure
			not_too_far: p.distance (Result) <= max_dist
		end

	random_city (size_bound: DOUBLE): TRAFFIC_CITY is
			-- Fake city
		local
			x, y: DOUBLE
		do
			create Result.make (random.alpha_string_nonempty_item (20))
			random.forth
			x := random.bounded_real_item (-size_bound, size_bound)
			random.forth
			y := random.bounded_real_item (-size_bound, size_bound)
			random.forth
			Result.set_center (create {TRAFFIC_POINT}.make (x, y))
			Result.set_radius (random.bounded_real_item (0, size_bound))
			random.forth
			if random.decide (0.5) then
				random.forth
				Result.set_description (random.alpha_string_or_void_item (1000))
			end
			random.forth
			if random.decide (0.5) then
				random.forth
				Result.set_scale_factor (random.bounded_real_item (1, 100_000))
			else
				random.forth
				Result.set_scale_factor (random.bounded_real_item (0, 1))
			end
			random.forth
		end
end
